import java.net.*;
import java.io.*;
import com.holub.io.Std;

public class Io_block
{
	public Io_block()
	{
		// Create a Server thread that opens a server-side
		// socket and just sits on it.

		Thread server = new Thread()	//#server
		{	public void run( )
			{	try
				{ 	ServerSocket server = new ServerSocket(9999);
					Socket client = server.accept();
					synchronized(this){ wait(); }
				}
				catch(Exception e)
				{	Std.out().println( e.getMessage() );
					return;
				}
			}
		};
		server.start();	//#end_server

		// Create a Client-side socket that reads from the
		// Server-side socket. Then create a thread that
		// attempts to read from the client-side socket.
		// I expect this thread to block since the server
		// never writes anything.

		try
		{ 	Thread.currentThread().sleep( 5 );
			Socket socket = new Socket("localhost", 9999);		//#client
			final InputStream in = socket.getInputStream();

			Thread client = new Thread()
			{	public void run()
				{	
					try
					{	in.read();	//#client_read
					}
					catch(Exception e)
					{	Std.out().println("-------------------");
						Std.out().println("  READ  EXCEPTION  ");
						Std.out().println("-------------------");
						e.printStackTrace();
					}	Std.out().println("-------------------");

				}
			};
			client.start();


			// The client is now blocked, waiting for the server
			// thread to write something (which it never does).

			client.interrupt();	// This operation blocks forever	//#noop

			in.close();			// This operation causes read() to	//#terminates
								// return with an I/O exception.
		}
		catch(Exception e)
		{	Std.out().println( e.getMessage() );
			return;
		}
	}

	public static void main( String[] args )
	{	new Io_block();
	}
}
