import java.awt.*;
import java.awt.event.*;
import com.holub.asynch.Condition;

public class Input_source_fixed extends Frame
{
	Condition	text_has_been_entered = new Condition(false); // Initial condition is false

	TextField input = new TextField();

	public Input_source_fixed()
	{
		input.addActionListener
		(	new ActionListener()
			{	public void actionPerformed( ActionEvent e )
				{	text_has_been_entered.set_true();  // set the condition true
				}
			}
		);

		add(input);
		pack();
		show();
	}

	/** A blocking function that works like readLine(), but gets its
	 *  text from the current window's text area. The function doesn't
	 *  return until sombody types a line of text, whereupon it returns
	 *  the line. Returns null if the user types an empty line.
	 */

	synchronized String read_line() throws InterruptedException
	{
		text_has_been_entered.wait_for_true();
		text_has_been_entered.set_false();

		String entered = input.getText();
		input.setText("");
		return (entered.length() == 0) ? null : entered;

	}


	static public void main( String[] args ) throws Exception
	{	Input_source_fixed source = new Input_source_fixed();
		String input;

		while( (input = source.read_line()) != null )
			System.out.println("Got: " + input );

		System.exit(0);			// kill the AWT Thread on exit
	}
}
