class Thread_creation_overhead
{
	final int trys = 10000;

	public Thread_creation_overhead()
	{
		time( "Creating " + trys + " Strings",
			  new Runnable(){ public void run()
			  {
					String s;
					for( int i = trys; --i >= 0 ; )
						s = new String("abc");
			  }}
			);

		time( "Creating " + trys + " Threads",
			  new Runnable(){ public void run()
			  {
					Thread t;
					for( int i = trys; --i >= 0 ; )
						t = new My_thread();
			  }}
			);

		time( "Creating and starting " + trys + " Threads",
			  new Runnable(){ public void run()
			  {
					Thread t;
					for( int i = trys; --i >= 0 ; )
					{
						t = new My_thread();
						t.start();
					}
			  }}
			);
	}

	private void time( String description, Runnable operation )
	{
		long start = System.currentTimeMillis();
		operation.run();
		long end   = System.currentTimeMillis();

		System.out.println( description
							+ " took " 
							+ ( ((double)end-start)/trys ) 
							+ " milliseconds per operation." );
	}

	private static class My_thread extends Thread
	{	public void run(){}
	}

	public static void main( String[] arguments )
	{	new Thread_creation_overhead();
	}
}
