import com.holub.asynch.Reader_writer;	//<b>
import com.holub.asynch.Thread_pool;	//</b>
import java.io.*;

class Thread_pool_flush
{//<b>
	Thread_pool pool = new Thread_pool( 3, 10 );	//</b>

	public interface Flush_error_handler
	{	void error( IOException e );
	}

	private final OutputStream	out;
	private Reader_writer		lock = new Reader_writer();
	private byte[]				buffer;
	private int					length;

	public Thread_pool_flush( OutputStream out )
	{	this.out = out;
	}
	//...
	synchronized void flush( final Flush_error_handler handler )
	{//<b>	
		pool.execute 
		(	new Runnable()				//</b>
			{	int 	length; 
				byte[]	copy;

				{	length = Thread_pool_flush.this.length;		//#constructor
					copy   = new byte[length];
					System.arraycopy(Thread_pool_flush.this.buffer, 0,
														copy, 0, length);
					Thread_pool_flush.this.length = 0;
				}

				public void run()
				{	try
					{	lock.request_write();
						out.write( copy, 0, length );
					}
					catch( Exception e )
					{	handler.error(e);	//#err
					}
					finally
					{	lock.write_accomplished();
					}
				}
			}//<b>
		);//</b>
	}
}		  
